diff --git a/wcs/publisher.py b/wcs/publisher.py
index 2877c5d8..b41a2182 100644
--- a/wcs/publisher.py
+++ b/wcs/publisher.py
@@ -55,6 +55,7 @@ from . import custom_views
 from . import sessions
 from .qommon.cron import CronJob
 
+from .roles import Role
 from .users import User
 from .tracking_code import TrackingCode
 
@@ -157,6 +158,7 @@ class WcsPublisher(StubWcsPublisher):
             from . import sql
 
             self.user_class = sql.SqlUser
+            self.role_class = sql.Role
             self.tracking_code_class = sql.TrackingCode
             self.session_class = sql.Session
             self.custom_view_class = sql.CustomView
@@ -165,6 +167,7 @@ class WcsPublisher(StubWcsPublisher):
             sql.get_connection(new=True)
         else:
             self.user_class = User
+            self.role_class = Role
             self.tracking_code_class = TrackingCode
             self.session_class = sessions.BasicSession
             self.custom_view_class = custom_views.CustomView
@@ -218,7 +221,13 @@ class WcsPublisher(StubWcsPublisher):
         for f in z.namelist():
             if '.indexes' in f:
                 continue
-            if os.path.dirname(f) in ('formdefs_xml', 'carddefs_xml', 'workflows_xml', 'blockdefs_xml'):
+            if os.path.dirname(f) in (
+                'formdefs_xml',
+                'carddefs_xml',
+                'workflows_xml',
+                'blockdefs_xml',
+                'roles_xml',
+            ):
                 continue
             path = os.path.join(self.app_dir, f)
             if not os.path.exists(os.path.dirname(path)):
@@ -284,6 +293,15 @@ class WcsPublisher(StubWcsPublisher):
                 carddefs.append(carddef)
                 results['carddefs'] += 1
 
+        # sixth pass, roles
+        roles = []
+        for f in z.namelist():
+            if os.path.dirname(f) == 'roles_xml' and os.path.basename(f):
+                role = self.role_class.import_from_xml(z.open(f), include_id=True)
+                role.store()
+                roles.append(role)
+                results['roles'] += 1
+
         # rebuild indexes for imported objects
         for k, v in results.items():
             if k == 'settings':
@@ -306,9 +324,7 @@ class WcsPublisher(StubWcsPublisher):
 
                 klass = Category
             elif k == 'roles':
-                from .roles import Role
-
-                klass = Role
+                klass = self.role_class
             elif k == 'workflows':
                 from wcs.workflows import Workflow
 
@@ -335,6 +351,7 @@ class WcsPublisher(StubWcsPublisher):
         sql.get_connection(new=True)
         sql.do_session_table()
         sql.do_user_table()
+        sql.do_role_table()
         sql.do_tracking_code_table()
         sql.do_custom_views_table()
         sql.do_snapshots_table()
diff --git a/wcs/qommon/saml2.py b/wcs/qommon/saml2.py
index f19fd0f5..4d9c72e0 100644
--- a/wcs/qommon/saml2.py
+++ b/wcs/qommon/saml2.py
@@ -36,7 +36,6 @@ from . import misc
 from .publisher import get_cfg, get_logger
 from . import _, force_str
 from .template import error_page
-from wcs.roles import Role
 
 from . import errors
 
@@ -495,7 +494,7 @@ class Saml2Directory(Directory):
             # point roles in authentic where provisionned from w.c.s. and join
             # was done on the slug field.
             for uuid in m['role-slug']:
-                role = Role.resolve(uuid)
+                role = get_publisher().role_class.resolve(uuid)
                 if not role:
                     logger.warning('role uuid %s is unknown', uuid)
                     continue
diff --git a/wcs/qommon/sessions.py b/wcs/qommon/sessions.py
index 7fd0b8c3..477e9af1 100644
--- a/wcs/qommon/sessions.py
+++ b/wcs/qommon/sessions.py
@@ -175,7 +175,6 @@ class Session(QommonSession, CaptchaSession, StorableObject):
 
     def create_form_token(self):
         token = super(Session, self).create_form_token()
-        print('created token:', token)
         open(self.get_form_token_filepath(token), 'wb').close()
         return token
 
diff --git a/wcs/qommon/templatetags/qommon.py b/wcs/qommon/templatetags/qommon.py
index f5bee1a1..8020ab95 100644
--- a/wcs/qommon/templatetags/qommon.py
+++ b/wcs/qommon/templatetags/qommon.py
@@ -26,6 +26,7 @@ import unicodedata
 
 import pyproj
 from pyproj import Geod
+from quixote import get_publisher
 
 try:
     import langdetect
@@ -43,7 +44,6 @@ from wcs.qommon import calendar
 from wcs.qommon import evalutils
 from wcs.qommon import tokens
 from wcs.qommon.admin.texts import TextsDirectory
-from wcs.roles import Role
 
 register = template.Library()
 
@@ -698,7 +698,7 @@ def has_role(user, role_name):
         return False
     for role_id in user.get_roles():
         try:
-            if role_name == Role.get(role_id).name:
+            if role_name == get_publisher().role_class.get(role_id).name:
                 return True
         except KeyError:  # role has been deleted
             pass
@@ -711,7 +711,7 @@ def roles(user):
         # do not fail on non-user objects, just return empty list
         return []
     role_ids = user.get_roles()
-    roles = [Role.get(x, ignore_errors=True, ignore_migration=True) for x in role_ids]
+    roles = [get_publisher().role_class.get(x, ignore_errors=True, ignore_migration=True) for x in role_ids]
     return [x.name for x in roles if x]
 
 
diff --git a/wcs/roles.py b/wcs/roles.py
index 6963d527..03d6c7a9 100644
--- a/wcs/roles.py
+++ b/wcs/roles.py
@@ -14,6 +14,8 @@
 # You should have received a copy of the GNU General Public License
 # along with this program; if not, see <http://www.gnu.org/licenses/>.
 
+import xml.etree.ElementTree as ET
+
 from django.utils.encoding import force_text
 from quixote import get_publisher
 
@@ -24,6 +26,7 @@ from .qommon.storage import StorableObject
 class Role(StorableObject):
     _names = 'roles'
     _indexes = ['uuid', 'slug']
+    xml_root_node = 'role'
 
     name = None
     uuid = None
@@ -34,6 +37,9 @@ class Role(StorableObject):
     emails_to_members = False
     allows_backoffice_access = True
 
+    TEXT_ATTRIBUTES = ['name', 'uuid', 'slug', 'details', 'emails']
+    BOOLEAN_ATTRIBUTES = ['internal', 'emails_to_members', 'allows_backoffice_access']
+
     def __init__(self, name=None, id=None):
         StorableObject.__init__(self, id=id)
         self.name = name
@@ -98,6 +104,59 @@ class Role(StorableObject):
             'id': self.id,
         }
 
+    def export_to_xml(self, include_id=False):
+        charset = get_publisher().site_charset
+        root = ET.Element(self.xml_root_node)
+        if include_id and self.id:
+            root.attrib['id'] = str(self.id)
+        for text_attribute in list(self.TEXT_ATTRIBUTES):
+            if not hasattr(self, text_attribute) or not getattr(self, text_attribute):
+                continue
+            ET.SubElement(root, text_attribute).text = force_text(getattr(self, text_attribute), charset)
+        for boolean_attribute in self.BOOLEAN_ATTRIBUTES:
+            if not hasattr(self, boolean_attribute):
+                continue
+            value = getattr(self, boolean_attribute)
+            if value:
+                value = 'true'
+            else:
+                value = 'false'
+            ET.SubElement(root, boolean_attribute).text = value
+        return root
+
+    @classmethod
+    def import_from_xml(cls, fd, charset=None, include_id=False):
+        try:
+            tree = ET.parse(fd)
+        except Exception:
+            raise ValueError()
+
+        if charset is None:
+            charset = get_publisher().site_charset
+        assert charset == 'utf-8'
+        role = cls()
+
+        # if the tree we get is actually a ElementTree for real, we get its
+        # root element and go on happily.
+        if not ET.iselement(tree):
+            tree = tree.getroot()
+
+        if include_id and tree.attrib.get('id'):
+            role.id = tree.attrib.get('id')
+        for text_attribute in list(cls.TEXT_ATTRIBUTES):
+            value = tree.find(text_attribute)
+            if value is None or value.text is None:
+                continue
+            setattr(role, text_attribute, misc.xml_node_text(value))
+
+        for boolean_attribute in cls.BOOLEAN_ATTRIBUTES:
+            value = tree.find(boolean_attribute)
+            if value is None:
+                continue
+            setattr(role, boolean_attribute, value.text == 'true')
+
+        return role
+
     @classmethod
     def resolve(cls, uuid, slug=None, name=None):
         try:
@@ -132,5 +191,11 @@ def logged_users_role():
 
 
 def get_user_roles():
-    t = sorted([(misc.simplify(x.name), x.id, x.name, x.id) for x in Role.select() if not x.is_internal()])
+    t = sorted(
+        [
+            (misc.simplify(x.name), x.id, x.name, x.id)
+            for x in get_publisher().role_class.select()
+            if not x.is_internal()
+        ]
+    )
     return [x[1:] for x in t]
diff --git a/wcs/sql.py b/wcs/sql.py
index 315a73f6..9e3502e9 100644
--- a/wcs/sql.py
+++ b/wcs/sql.py
@@ -46,6 +46,7 @@ import wcs.carddata
 import wcs.custom_views
 import wcs.formdata
 import wcs.logged_errors
+import wcs.roles
 import wcs.snapshots
 import wcs.tracking_code
 import wcs.users
@@ -802,6 +803,57 @@ def do_user_table():
     cur.close()
 
 
+def do_role_table(concurrently=False):
+    conn, cur = get_connection_and_cursor()
+    table_name = 'roles'
+
+    cur.execute(
+        '''SELECT COUNT(*) FROM information_schema.tables
+                    WHERE table_schema = 'public'
+                      AND table_name = %s''',
+        (table_name,),
+    )
+    if cur.fetchone()[0] == 0:
+        cur.execute(
+            '''CREATE TABLE %s (id VARCHAR PRIMARY KEY,
+                                name VARCHAR,
+                                uuid UUID,
+                                slug VARCHAR UNIQUE,
+                                internal BOOLEAN,
+                                details VARCHAR,
+                                emails VARCHAR[],
+                                emails_to_members BOOLEAN,
+                                allows_backoffice_access BOOLEAN)'''
+            % table_name
+        )
+    cur.execute(
+        '''SELECT column_name FROM information_schema.columns
+                    WHERE table_schema = 'public'
+                      AND table_name = %s''',
+        (table_name,),
+    )
+    existing_fields = set([x[0] for x in cur.fetchall()])
+
+    needed_fields = set([x[0] for x in Role._table_static_fields])
+
+    # delete obsolete fields
+    for field in existing_fields - needed_fields:
+        cur.execute('''ALTER TABLE %s DROP COLUMN %s''' % (table_name, field))
+
+    conn.commit()
+    cur.close()
+
+
+def migrate_legacy_roles():
+    # store old pickle roles in SQL
+    from wcs import roles
+
+    for role_id in roles.Role.keys():
+        role = roles.Role.get(role_id)
+        role.__class__ = Role
+        role.store()
+
+
 def do_tracking_code_table():
     conn, cur = get_connection_and_cursor()
     table_name = 'tracking_codes'
@@ -1401,8 +1453,8 @@ class SqlMixin(object):
 
     @classmethod
     @guard_postgres
-    def get(cls, id, ignore_errors=False, ignore_migration=False):
-        if cls._numerical_id or id is None:
+    def get(cls, id, ignore_errors=False, ignore_migration=False, column=None):
+        if column is None and (cls._numerical_id or id is None):
             try:
                 int(id)
             except (TypeError, ValueError):
@@ -1414,11 +1466,12 @@ class SqlMixin(object):
 
         sql_statement = '''SELECT %s
                              FROM %s
-                            WHERE id = %%(id)s''' % (
+                            WHERE %s = %%(value)s''' % (
             ', '.join([x[0] for x in cls._table_static_fields] + cls.get_data_fields()),
             cls._table_name,
+            column or 'id',
         )
-        cur.execute(sql_statement, {'id': str(id)})
+        cur.execute(sql_statement, {'value': str(id)})
         row = cur.fetchone()
         if row is None:
             cur.close()
@@ -1428,6 +1481,11 @@ class SqlMixin(object):
         cur.close()
         return cls._row2ob(row)
 
+    @classmethod
+    @guard_postgres
+    def get_on_index(cls, value, index, ignore_errors=False, **kwargs):
+        return cls.get(value, ignore_errors=ignore_errors, column=index)
+
     @classmethod
     @guard_postgres
     def get_ids(cls, ids, ignore_errors=False, keep_order=False, fields=None, order_by=None):
@@ -2447,6 +2505,93 @@ class SqlUser(SqlMixin, wcs.users.User):
         return objects
 
 
+class Role(SqlMixin, wcs.roles.Role):
+    _table_name = 'roles'
+    _table_static_fields = [
+        ('id', 'varchar'),
+        ('name', 'varchar'),
+        ('uuid', 'uuid'),
+        ('slug', 'varchar'),
+        ('internal', 'boolean'),
+        ('details', 'varchar'),
+        ('emails', 'varchar[]'),
+        ('emails_to_members', 'boolean'),
+        ('allows_backoffice_access', 'boolean'),
+    ]
+
+    _numerical_id = False
+
+    @guard_postgres
+    def store(self):
+        if self.slug is None:
+            # set slug if it's not yet there
+            self.slug = self.get_new_slug()
+
+        sql_dict = {
+            'id': self.id,
+            'name': self.name,
+            'uuid': self.uuid,
+            'slug': self.slug,
+            'internal': self.internal,
+            'details': self.details,
+            'emails': self.emails,
+            'emails_to_members': self.emails_to_members,
+            'allows_backoffice_access': self.allows_backoffice_access,
+        }
+
+        conn, cur = get_connection_and_cursor()
+        column_names = sql_dict.keys()
+
+        if not self.id:
+            sql_dict['id'] = self.get_new_id()
+            sql_statement = '''INSERT INTO %s (%s)
+                               VALUES (%s)
+                               RETURNING id''' % (
+                self._table_name,
+                ', '.join(column_names),
+                ', '.join(['%%(%s)s' % x for x in column_names]),
+            )
+            while True:
+                try:
+                    cur.execute(sql_statement, sql_dict)
+                except psycopg2.IntegrityError:
+                    conn.rollback()
+                    sql_dict['id'] = self.get_new_id()
+                else:
+                    break
+            self.id = str_encode(cur.fetchone()[0])
+        else:
+            sql_statement = '''UPDATE %s SET %s WHERE id = %%(id)s RETURNING id''' % (
+                self._table_name,
+                ', '.join(['%s = %%(%s)s' % (x, x) for x in column_names]),
+            )
+            cur.execute(sql_statement, sql_dict)
+            if cur.fetchone() is None:
+                sql_statement = '''INSERT INTO %s (%s) VALUES (%s)''' % (
+                    self._table_name,
+                    ', '.join(column_names),
+                    ', '.join(['%%(%s)s' % x for x in column_names]),
+                )
+                cur.execute(sql_statement, sql_dict)
+
+        conn.commit()
+        cur.close()
+
+    @classmethod
+    def get_data_fields(cls):
+        return []
+
+    @classmethod
+    def _row2ob(cls, row, **kwargs):
+        o = cls()
+        for field, value in zip(cls._table_static_fields, tuple(row)):
+            if field[1] in ('varchar', 'varchar[]'):
+                setattr(o, field[0], str_encode(value))
+            else:
+                setattr(o, field[0], value)
+        return o
+
+
 class Session(SqlMixin, wcs.sessions.BasicSession):
     _table_name = 'sessions'
     _table_static_fields = [
@@ -3145,7 +3290,7 @@ def get_period_total(
 # latest migration, number + description (description is not used
 # programmaticaly but will make sure git conflicts if two migrations are
 # separately added with the same number)
-SQL_LEVEL = (48, 'remove acked attribute from LoggedError')
+SQL_LEVEL = (49, 'Role migration')
 
 
 def migrate_global_views(conn, cur):
@@ -3316,6 +3461,10 @@ def migrate():
         # 47: store LoggedErrors in SQL
         # 48: remove acked attribute from LoggedError
         do_loggederrors_table()
+    if sql_level < 49:
+        # 49: store Role in SQL
+        do_role_table()
+        migrate_legacy_roles()
 
     cur.execute('''UPDATE wcs_meta SET value = %s WHERE key = %s''', (str(SQL_LEVEL[0]), 'sql_level'))
 
diff --git a/wcs/users.py b/wcs/users.py
index 4ac07fc0..91dcb8a8 100644
--- a/wcs/users.py
+++ b/wcs/users.py
@@ -16,6 +16,8 @@
 
 import datetime
 
+from quixote import get_publisher
+
 from .qommon import _, N_
 from .qommon.misc import simplify
 from .qommon.storage import StorableObject
@@ -134,11 +136,10 @@ class User(StorableObject):
             return True
         if self.anonymous:
             return False
-        from .roles import Role
 
         for role_id in self.roles or []:
             try:
-                role = Role.get(role_id)
+                role = get_publisher().role_class.get(role_id)
                 if role.allows_backoffice_access:
                     return True
             except KeyError:  # role has been deleted
diff --git a/wcs/variables.py b/wcs/variables.py
index bedda9f9..0868f16a 100644
--- a/wcs/variables.py
+++ b/wcs/variables.py
@@ -493,8 +493,6 @@ class LazyFormData(LazyFormDef):
 
     @property
     def role(self):
-        from wcs.roles import Role
-
         workflow_roles = {}
         if self._formdef.workflow_roles:
             workflow_roles.update(self._formdef.workflow_roles)
@@ -505,7 +503,7 @@ class LazyFormData(LazyFormDef):
         for role_type, role_id in workflow_roles.items():
             prefix = '%s_' % role_type.replace('-', '_').strip('_')
             try:
-                d.update(Role.get(role_id).get_substitution_variables(prefix))
+                d.update(get_publisher().role_class.get(role_id).get_substitution_variables(prefix))
             except KeyError:
                 pass
         return d
diff --git a/wcs/wf/aggregation_email.py b/wcs/wf/aggregation_email.py
index 5a23a610..7f737fa8 100644
--- a/wcs/wf/aggregation_email.py
+++ b/wcs/wf/aggregation_email.py
@@ -22,7 +22,6 @@ from ..qommon.cron import CronJob
 from ..qommon import emails
 
 from wcs.workflows import WorkflowStatusItem, register_item_class
-from wcs.roles import Role
 
 
 class AggregationEmailWorkflowStatusItem(WorkflowStatusItem):
@@ -110,7 +109,7 @@ def send_aggregation_emails(publisher):
         aggregate.remove_self()
 
         try:
-            role = Role.get(aggregate_id)
+            role = get_publisher().role_class.get(aggregate_id)
         except KeyError:
             continue
         if not role.get_emails():
diff --git a/wcs/wf/dispatch.py b/wcs/wf/dispatch.py
index 6b6952fd..3c9d0ab3 100644
--- a/wcs/wf/dispatch.py
+++ b/wcs/wf/dispatch.py
@@ -22,7 +22,7 @@ from quixote.html import htmltext
 from ..qommon import _, N_
 from ..qommon.form import *
 from ..qommon.template import Template
-from wcs.roles import Role, get_user_roles
+from wcs.roles import get_user_roles
 from wcs.workflows import XmlSerialisable, WorkflowStatusItem, register_item_class, get_role_name
 
 
@@ -232,7 +232,7 @@ class DispatchWorkflowStatusItem(WorkflowStatusItem):
                     break
 
         if new_role_id:
-            if not Role.has_key(new_role_id):
+            if not get_publisher().role_class.get(new_role_id, ignore_errors=True):
                 get_publisher().record_error(
                     _('error in dispatch, missing role (%s)') % new_role_id, formdata=formdata
                 )
diff --git a/wcs/wf/notification.py b/wcs/wf/notification.py
index b9a914af..d93e59a0 100644
--- a/wcs/wf/notification.py
+++ b/wcs/wf/notification.py
@@ -23,7 +23,6 @@ from ..qommon.form import *
 from ..qommon.template import TemplateError
 from ..qommon import get_logger
 
-from wcs.roles import Role
 from wcs.workflows import WorkflowStatusItem, register_item_class, template_on_formdata
 from .wscall import WebserviceCallStatusItem
 
@@ -156,7 +155,7 @@ class SendNotificationWorkflowStatusItem(WebserviceCallStatusItem):
 
             dest = formdata.get_role_translation(dest)
             try:
-                role = Role.get(dest)
+                role = get_publisher().role_class.get(dest)
             except KeyError:
                 continue
             users.extend(get_publisher().user_class.get_users_with_role(role.id))
diff --git a/wcs/wf/roles.py b/wcs/wf/roles.py
index c16d0467..fbc25e77 100644
--- a/wcs/wf/roles.py
+++ b/wcs/wf/roles.py
@@ -22,7 +22,7 @@ from quixote import get_request, get_publisher, get_response
 from ..qommon import _, N_
 from ..qommon.form import *
 from wcs.workflows import WorkflowStatusItem, register_item_class
-from wcs.roles import get_user_roles, Role
+from wcs.roles import get_user_roles
 from ..qommon.ident.idp import is_idp_managing_user_attributes
 from ..qommon.misc import http_post_request, http_delete_request
 from ..qommon.publisher import get_cfg, get_logger
@@ -99,7 +99,7 @@ class AddRoleWorkflowStatusItem(WorkflowStatusItem):
             request._user = user
 
     def perform_idp(self, user, formdata, role_id):
-        role = Role.get(role_id)
+        role = get_publisher().role_class.get(role_id)
         role_uuid = role.uuid or role.slug
         user_uuid = user.name_identifiers[0]
         try:
@@ -169,7 +169,7 @@ class RemoveRoleWorkflowStatusItem(WorkflowStatusItem):
                 request._user = user
 
     def perform_idp(self, user, formdata, role_id):
-        role = Role.get(role_id)
+        role = get_publisher().role_class.get(role_id)
         role_uuid = role.uuid or role.slug
         user_uuid = user.name_identifiers[0]
         try:
diff --git a/wcs/workflows.py b/wcs/workflows.py
index 9d95bf6d..5172b1fa 100644
--- a/wcs/workflows.py
+++ b/wcs/workflows.py
@@ -27,7 +27,7 @@ import uuid
 
 from django.utils.encoding import force_text
 
-from quixote import get_request, get_response, redirect
+from quixote import get_request, get_response, redirect, get_publisher
 
 from .qommon import _, N_, force_str
 from .qommon.misc import C_, get_as_datetime, file_digest, get_foreground_colour, xml_node_text
@@ -41,7 +41,7 @@ from .qommon.template import Template, TemplateError
 from .qommon.upload_storage import PicklableUpload, get_storage_object
 
 from .conditions import Condition
-from .roles import Role, logged_users_role, get_user_roles
+from .roles import logged_users_role, get_user_roles
 from .fields import FileField
 from .formdef import FormDef, FormdefImportError
 from .carddef import CardDef
@@ -1022,13 +1022,13 @@ class XmlSerialisable(object):
         # if we import using id, look at the role_id attribute
         if include_id and 'role_id' in elem.attrib:
             role_id = force_str(elem.attrib['role_id'])
-            if Role.has_key(role_id):
+            if get_publisher().role_class.get(role_id, ignore_errors=True):
                 return role_id
             if WorkflowStatusItem.get_expression(role_id)['type'] in ('python', 'template'):
                 return role_id
 
         # if not using id, look up on the name
-        for role in Role.select(ignore_errors=True):
+        for role in get_publisher().role_class.select(ignore_errors=True):
             if role.name == value:
                 return role.id
 
@@ -1042,7 +1042,7 @@ class XmlSerialisable(object):
             raise WorkflowImportError(N_('Unknown referenced role (%s)'), (value,))
 
         # and if there's no match, create a new role
-        role = Role()
+        role = get_publisher().role_class()
         role.name = value
         role.store()
         return role.id
@@ -2125,14 +2125,14 @@ class WorkflowStatusItem(XmlSerialisable):
 
     def get_computed_role_id(self, role_id):
         new_role_id = self.compute(str(role_id))
-        if Role.has_key(new_role_id):
+        if get_publisher().role_class.get(new_role_id, ignore_errors=True):
             return new_role_id
         # computed value, not an id, try to get role by slug
-        new_role = Role.get_on_index(new_role_id, 'slug', ignore_errors=True)
+        new_role = get_publisher().role_class.get_on_index(new_role_id, 'slug', ignore_errors=True)
         if new_role:
             return new_role.id
         # fallback to role label
-        for role in Role.select():
+        for role in get_publisher().role_class.select():
             if role.name == new_role_id:
                 return role.id
         return None
@@ -2396,7 +2396,7 @@ def get_role_translation_label(workflow, role_id):
         return workflow.roles.get(role_id)
     else:
         try:
-            return Role.get(role_id).name
+            return get_publisher().role_class.get(role_id).name
         except KeyError:
             return
 
@@ -2406,7 +2406,7 @@ def get_role_name(role_id, charset=None):
     if role_id.startswith('_') or role_id == 'logged-users':
         return force_text(role_id, charset)
     try:
-        return force_text(Role.get(role_id).name, charset)
+        return force_text(get_publisher().role_class.get(role_id).name, charset)
     except KeyError:
         return force_text(role_id, charset)
 
@@ -2943,7 +2943,7 @@ class SendmailWorkflowStatusItem(WorkflowStatusItem):
             dest = formdata.get_role_translation(dest)
 
             try:
-                role = Role.get(dest)
+                role = get_publisher().role_class.get(dest)
             except KeyError:
                 continue
             addresses.extend(role.get_emails())
-- 
2.30.1

